#include <Application.h>
#include <Messenger.h>
#include <Message.h>
#include <Roster.h>
#include <Window.h>
#include <View.h>
#include <MenuBar.h>
#include <Menu.h>
#include <MenuItem.h>

const char *APP_NAME					= "Potato Head";

const uint32 HAPPY_EYES			= 'EH';
const uint32 MAD_EYES			= 'EM';
const uint32 CONFUSED_EYES		= 'EC';
const uint32 SMALL_NOSE			= 'NS';
const uint32 BIG_NOSE			= 'NB';
const uint32 MOO_COW			= 'NMC';
const uint32 SMILE_MOUTH		= 'MS';
const uint32 TONGUE_MOUTH		= 'MT';
const uint32 FANGS_MOUTH		= 'MF';
const uint32 BIG_EARS			= 'EB';
const uint32 SMALL_EARS			= 'ES';
const uint32 ARROW_EARS			= 'EA';
const uint32 CLEAR_POTATO		= 'PC';

int eyes, ears, nose, mouth;

class PotatoView : public BView
{
	public:
		PotatoView(BRect frame);
		virtual void Draw(BRect updateRect);
		
};

PotatoView::PotatoView(BRect frame):BView(frame, "PotatoView", 
					B_FOLLOW_ALL_SIDES, B_WILL_DRAW)
{
// Nothing happens here
}


void PotatoView::Draw(BRect updateRect)
{
	SetPenSize(5);
	
	SetHighColor(255,170,115,0);
	FillEllipse(BRect(100,50,250,300));  //potato
	
	SetHighColor(0,0,255,0);  //shoes
	FillArc(BPoint(150,320),40,30,0,180);
	FillArc(BPoint(200,320),40,30,0,180);
	SetHighColor(255,255,255,0);
	StrokeLine(BPoint(140,300),BPoint(160,300));
	StrokeLine(BPoint(140,310),BPoint(160,310));
	StrokeLine(BPoint(190,300),BPoint(210,300));
	StrokeLine(BPoint(190,310),BPoint(210,310));
	
	switch (eyes)
	{
		case 1:
		{
			SetHighColor(255,255,255,0);
			FillEllipse(BRect(130,120,170,160));  //left eye
			FillEllipse(BRect(180,120,220,160));  //right eye
	
			SetHighColor(0,0,0,0);
			StrokeArc(BPoint(175,110),50,10,0,180);  //happy
			FillEllipse(BPoint(150,140),5,5);  //left pupil
			FillEllipse(BPoint(200,140),5,5);  //right pupil
		}
		break;
		
		case 2:
		{
			SetHighColor(255,255,255,0);  //white
			FillEllipse(BRect(130,120,170,160));  //left eye
			FillEllipse(BRect(180,120,220,160));  //right eye
	
			SetHighColor(0,0,0,0);  //black
			StrokeArc(BPoint(175,100),50,10,180,180);  //sad
			FillEllipse(BPoint(150,140),5,5);  //left pupil
			FillEllipse(BPoint(200,140),5,5);  //right pupil
		}
		break;
		
		case 3:
		{
			SetHighColor(255,255,255,0);  //white
			FillEllipse(BRect(130,120,170,160));  //left eye
			FillEllipse(BRect(180,120,220,160));  //right eye
			SetHighColor(0,0,0,0);  //black
			StrokeEllipse(BPoint(140,150),5,5);  //left confused
			StrokeEllipse(BPoint(210,130),5,5);  //right confused
		}
		break;
	default:
		//I need a bit bucket
		break;
	}
	
	switch (ears)
	{
		case 1:
		{
			SetHighColor(255,230,125,0);
			FillArc(BPoint(250,170),30,40,264,194);  //big ears
			FillArc(BPoint(100,170),30,40,82,192);
		}
		break;
		
		case 2:
		{
			SetHighColor(255,230,125,0);
			FillArc(BPoint(100,170),15,30,84,186);  //small ear
			FillArc(BPoint(250,170),15,30,266,194);
		}
		break;
		
		case 3:
		{
			SetHighColor(0,0,0,0);
			StrokeLine(BPoint(50,170),BPoint(100,170));
			StrokeLine(BPoint(250,170),BPoint(300,170));
			FillTriangle(BPoint(45,170),BPoint(70,190),BPoint(70,150));
			SetHighColor(255,0,0,0);
			StrokeLine(BPoint(290,150),BPoint(280,170));
			StrokeLine(BPoint(280,170),BPoint(290,190));
			SetHighColor(0,255,0,0);
			StrokeLine(BPoint(300,150),BPoint(290,170));
			StrokeLine(BPoint(290,170),BPoint(300,190));
			SetHighColor(0,0,255,0);
			StrokeLine(BPoint(310,150),BPoint(300,170));
			StrokeLine(BPoint(300,170),BPoint(310,190));
		}
		break;
	default:
		//I need a bit bucket
		break;
	}
	
	switch (mouth)
	{
		case 1:
		{
			SetHighColor(0,0,0,0);
			StrokeArc(BPoint(175,220),50,20,180,180);  //smile
		}
		break;
		
		case 2:
		{
			SetHighColor(0,0,0,0);
			StrokeArc(BPoint(175,220),50,20,180,180);  //smile
			SetHighColor(255,0,0,0);
			FillArc(BPoint(175,240),20,20,175,190);  //tongue
		}
		break;
		
		case 3:
		{
			SetHighColor(0,0,0,0);
			StrokeArc(BPoint(175,220),50,20,180,180);  //smile
			SetHighColor(255,255,255,0);
			FillTriangle(BPoint(140,235),BPoint(150,240),BPoint(145,250));  //fangs
			FillTriangle(BPoint(200,240),BPoint(210,235),BPoint(205,250));
		}
		break;
	default:
		//I need a bit bucket
		break;
	}
	
	switch (nose)
	{
		case 1:
		{
			SetHighColor(255,0,0,0);
			FillEllipse(BRect(170,160,180,190));  //small nose
		}
		break;
		
		case 2:
		{
			SetHighColor(255,0,0,0);
			FillEllipse(BRect(150,160,200,190));  //big nose
		}
		break;
		
		case 3:
		{
			SetHighColor(255,0,0,0);
			//FillEllipse(BRect(170,160,180,190));  //small nose
			FillEllipse(BRect(150,160,200,190));  //big nose
			SetHighColor(255,255,0,0);
			StrokeArc(BPoint(175,190),10,10,120,300);  //moo cow
		}
		break;
	default:
		//I need a bit bucket
		break;
	}
}


class PotatoWindow : public BWindow
{
	public:
		PotatoWindow(BRect frame);
		virtual bool QuitRequested();
		virtual void MessageReceived(BMessage *message);
		
	private:
		BMenuBar *menubar;
		PotatoView *pview;
};

PotatoWindow::PotatoWindow(BRect frame) : BWindow(frame, APP_NAME, B_TITLED_WINDOW,
									B_NOT_RESIZABLE|B_NOT_ZOOMABLE)
{
//Building menu
	BRect r;
	BMenu *menu;
	
	r = Bounds();
	menubar = new BMenuBar(r, "menu_bar");
	AddChild(menubar);
	
	menu = new BMenu("Eyes");
	menu->AddItem(new BMenuItem("Happy", new BMessage(HAPPY_EYES)));
	menu->AddItem(new BMenuItem("Mad", new BMessage(MAD_EYES)));
	menu->AddItem(new BMenuItem("Confused", new BMessage(CONFUSED_EYES)));
	menubar->AddItem(menu);
	
	menu = new BMenu("Nose");
	menu->AddItem(new BMenuItem("Small", new BMessage(SMALL_NOSE)));
	menu->AddItem(new BMenuItem("Big", new BMessage(BIG_NOSE)));
	menu->AddItem(new BMenuItem("Moo Cow", new BMessage(MOO_COW)));
	menubar->AddItem(menu);
	
	menu = new BMenu("Mouth");
	menu->AddItem(new BMenuItem("Smile", new BMessage(SMILE_MOUTH)));
	menu->AddItem(new BMenuItem("Tongue", new BMessage(TONGUE_MOUTH)));
	menu->AddItem(new BMenuItem("Fangs", new BMessage(FANGS_MOUTH)));
	menubar->AddItem(menu);
	
	menu = new BMenu("Ears");
	menu->AddItem(new BMenuItem("Big", new BMessage(BIG_EARS)));
	menu->AddItem(new BMenuItem("Small", new BMessage(SMALL_EARS)));
	menu->AddItem(new BMenuItem("Arrow", new BMessage(ARROW_EARS)));
	menubar->AddItem(menu);
	
	menu = new BMenu("Potato");
	menu->AddItem(new BMenuItem("Clear", new BMessage(CLEAR_POTATO)));
	menubar->AddItem(menu);
//end building menu
	
	r.top = menubar->Bounds().bottom+1;
	AddChild(pview = new PotatoView(r)); 
	Show();
}

void PotatoWindow::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
		case HAPPY_EYES:
		{
			eyes = 1;
			pview->Invalidate();
		}
		break;
		
		case MAD_EYES:
		{
			eyes = 2;
			pview->Invalidate();
		}
		break;
		
		case CONFUSED_EYES:
		{
			eyes = 3;
			pview->Invalidate();
		}
		break;
		
		case SMALL_NOSE:
		{
			nose = 1;
			pview->Invalidate();
		}
		break;
		
		case BIG_NOSE:
		{
			nose = 2;
			pview->Invalidate();
		}
		break;
		
		case MOO_COW:
		{
			nose = 3;
			pview->Invalidate();
		}
		break;
		
		case SMILE_MOUTH:
		{
			mouth = 1;
			pview->Invalidate();
		}
		break;
		
		case TONGUE_MOUTH:
		{
			mouth = 2;
			pview->Invalidate();
		}
		break;
		
		case FANGS_MOUTH:
		{
			mouth = 3;
			pview->Invalidate();
		}
		break;
		
		case BIG_EARS:
		{
			ears = 1;
			pview->Invalidate();
		}
		break;
		
		case SMALL_EARS:
		{
			ears = 2;
			pview->Invalidate();
		}
		break;
		
		case ARROW_EARS:
		{
			ears = 3;
			pview->Invalidate();
		}
		break;
		
		case CLEAR_POTATO:
		{
			eyes = 0;
			ears = 0;
			nose = 0;
			mouth = 0;
			pview->Invalidate();
		}
		break;
		
	default:
		BWindow::MessageReceived(message);
		break;
	}
}

bool PotatoWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}

class PotatoApp : public BApplication
{
	public:
		PotatoApp();
		
	private:
		PotatoWindow *theWindow;
};

PotatoApp::PotatoApp():BApplication("application/x-vnd.AGibson-Potato_Head")
{
	BRect windowRect;
	
	windowRect.Set(50,50,400,400);
	theWindow = new PotatoWindow(windowRect);
}

int main(void)
{
	eyes = 0;
	ears = 0;
	nose = 0;
	mouth = 0;
	
	PotatoApp *theApp;
	theApp = new(PotatoApp);
	theApp->Run();
	delete theApp;
}